(function(){
    "use strict";

    var QWeb = openerp.web.qweb;
    openerp.partner_print_credit = {};

    openerp.partner_print_credit.PrintCreditWidget = openerp.Widget.extend({
        template : "partner_print_credit.PrintCredit",
        resPartner:[],
        resConyuge:[],
        jsonDoc:[],
        ref_Personal:[],
        ref_Comercial:[],
        // Init
        init:function(parent){
              this._super(parent);
        },
        start: function () {
            var self = this;
            this.$el.click(function (e) {
                self.fecthInitial();
            });
        },
        fecthInitial: function(){
            var id= openerp.webclient._current_state.id;
            var self = this;
            self.fecthPartner(id).then(function(partner){
                return partner;
            }).then(function(partner){
                self.resPartner =partner;
                return self.fecthPartnerConyuge();
            }).then(function(res_conyuge){
                self.resConyuge=res_conyuge;
                return self.fecthPartnerPersonal();
            }).then(function(ref_Personal){
                self.ref_Personal =ref_Personal;
                return self.fecthPartnerComercial();
            }).then(function(ref_Comercial){
                self.ref_Comercial=ref_Comercial;
                return self.drawJSON();
            }).then(function(jsondoc){
                self.jsonDoc= jsondoc
                return self.drawPDF();
            });
            return false;
        },
        // Consultar Cliente
        fecthPartner: function(id){
            var defer = $.Deferred();
            var fields=['id','name','ruc','estado_civil','city','fecha_credito','street','phone','mobile','email','user_id','casa_propia', 'casa_alquiler','trab_empresa','trab_telefono','trab_street','trab_city','trab_cargo','trab_salario','trab_antiguedad_a','trab_antiguedad_m', 'conyuge_id','ref_personal_ids', 'ref_comercial_ids'];
            var domain=[['id','=', id]];
            var Partner = new openerp.web.Model('res.partner');
            Partner.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Consultar Conyugue
        fecthPartnerConyuge: function(){
            var self= this;
            var defer = $.Deferred();
            var partnerIDS = _.flatten(_.map(self.resPartner, function (item) {
                return item.conyuge_id[0];
            }));
            var fields=['id','name','ruc','city','street','phone','mobile','email','trab_empresa','trab_telefono','trab_street','trab_city'];
            var domain=[['id','=',partnerIDS]];
            var Partner = new openerp.web.Model('res.partner');
            Partner.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Consultar Conyugue
        fecthPartnerPersonal: function(){
            var self= this;
            var defer = $.Deferred();
            var partnerIDS = _.flatten(_.map(self.resPartner, function (item) {
                return item.ref_personal_ids;
            }));
            var fields=['id','name','phone','mobile'];
            var domain=[['id','=',partnerIDS]];
            var Partner = new openerp.web.Model('res.partner');
            Partner.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Consultar Conyugue
        fecthPartnerComercial: function(){
            var self= this;
            var defer = $.Deferred();
            var partnerIDS = _.flatten(_.map(self.resPartner, function (item) {
                return item.ref_comercial_ids;
            }));
            var fields=['id','name','phone','mobile'];
            var domain=[['id','=',partnerIDS]];
            var Partner = new openerp.web.Model('res.partner');
            Partner.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Obtener Datos del JSON
        drawJSON:function(){
            var defer = $.Deferred();
            $.getJSON('/partner_print_credit/static/src/json/print_credit.json').then(function(doc){
                defer.resolve(doc);
            });
            return defer;
        },
        // verificar null
        valorNull:function(dato){
            var valor ="";
            if (dato){
                if(dato == true && typeof dato == 'boolean'){
                    valor="X";
                }else{
                    valor=dato;
                }
            }
            return valor;
        },
        // formatear fecha
        formatDate: function(date){
            var fecha="";
            if (date){
                var fechaSel =date.split('-');
                fecha= (fechaSel[2]+"/"+fechaSel[1]+"/"+fechaSel[0]);
            }
            return fecha;
        },
        // Generar el PDF
        drawPDF:function(){
            var self = this;
            var doc=[];
            var pdfDoc = new jsPDF();
            var resPartner = self.resPartner.shift();
            var resConyuge = self.resConyuge;
            var ref_Personal = self.ref_Personal;
            var ref_Comercial = self.ref_Comercial;
            console.log(resPartner);
            console.log(ref_Personal);
            console.log(ref_Comercial);
            var fecha = new Date();
            // Generar Objeto
            doc.push({
                fecha : self.valorNull(self.formatDate(resPartner.fecha_credito)),
                id : self.valorNull(resPartner.id),
                name : self.valorNull(resPartner.name),
                ruc : self.valorNull(resPartner.ruc),
                estado_civil : self.valorNull(resPartner.estado_civil),
                city : self.valorNull(resPartner.city),
                street : self.valorNull(resPartner.street),
                phone : self.valorNull(resPartner.phone),
                mobile : self.valorNull(resPartner.mobile),
                email : self.valorNull(resPartner.email),
                user : self.valorNull(resPartner.user_id[1]),
                casa_propia : self.valorNull(resPartner.casa_propia),
                casa_alquiler : self.valorNull(resPartner.casa_alquiler),
                trab_empresa  : self.valorNull(resPartner.trab_empresa),
                trab_telefono : self.valorNull(resPartner.trab_telefono),
                trab_street  : self.valorNull(resPartner.trab_street),
                trab_city : self.valorNull(resPartner.trab_city),
                trab_cargo : self.valorNull(resPartner.trab_cargo),
                trab_salario : self.valorNull(accounting.formatNumber(resPartner.trab_salario , 2, ".", ",")),
                trab_antiguedad_a : self.valorNull(resPartner.trab_antiguedad_a),
                trab_antiguedad_m : self.valorNull(resPartner.trab_antiguedad_m)
            });
            if(doc){
                var item;
                for (var i = 0; i < doc.length; i++) {
                    item=doc[i];
                    _.each(self.jsonDoc,function(jsondoc){
                        var texto =_.template(jsondoc.content)(item);
                        // console.log(texto);
                        pdfDoc.setFontSize(jsondoc.size);
                        pdfDoc.setFontStyle(jsondoc.fontStyle);
                        pdfDoc.text(jsondoc.x,jsondoc.y, pdfDoc.splitTextToSize(texto,180),null,null,jsondoc.position);
                    })
                }
                // Si tiene Dactos de Conyuge
                if(resConyuge.length > 0){
                    for (var i = 0; i < resConyuge.length; i++) {
                        item=resConyuge[i];
                        pdfDoc.setFontSize('10');
                        pdfDoc.setFontStyle('normal');
                        pdfDoc.text(15,105, pdfDoc.splitTextToSize('Nombre y Apellido:  '+self.valorNull(item.name),180));
                        pdfDoc.text(140,105, pdfDoc.splitTextToSize('Cédula de Identidad Nro:  '+self.valorNull(item.ruc),180));
                        pdfDoc.text(15,110, pdfDoc.splitTextToSize('Teléfono Particular: Móvil:  '+self.valorNull(item.phone)+" "+self.valorNull(item.mobile),180));
                        pdfDoc.text(140,110, pdfDoc.splitTextToSize('Ciudad:  '+self.valorNull(item.mobile),180));
                        pdfDoc.text(15,115, pdfDoc.splitTextToSize('Direccion: '+self.valorNull(item.street),180));
                        pdfDoc.text(15,120, pdfDoc.splitTextToSize('Empresa o Lugar de Trabajo:  '+self.valorNull(item.trab_empresa),180));
                        pdfDoc.text(140,120, pdfDoc.splitTextToSize('Teléfono:  '+self.valorNull(item.trab_telefono),180));
                        pdfDoc.text(15,125, pdfDoc.splitTextToSize('Dirección Laboral:  '+self.valorNull(item.trab_street),180));
                    }
                }else{
                    pdfDoc.setFontSize('10');
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.text(15,105, pdfDoc.splitTextToSize('Nombre y Apellido:  ',180));
                    pdfDoc.text(140,105, pdfDoc.splitTextToSize('Cédula de Identidad Nro:  ',180));
                    pdfDoc.text(15,110, pdfDoc.splitTextToSize('Teléfono Particular: Móvil:  ',180));
                    pdfDoc.text(140,110, pdfDoc.splitTextToSize('Ciudad:  ',180));
                    pdfDoc.text(15,115, pdfDoc.splitTextToSize('Direccion: ',180));
                    pdfDoc.text(15,120, pdfDoc.splitTextToSize('Empresa o Lugar de Trabajo:  ',180));
                    pdfDoc.text(140,120, pdfDoc.splitTextToSize('Teléfono:  ',180));
                    pdfDoc.text(15,125, pdfDoc.splitTextToSize('Dirección Laboral:  ',180));
                }
                var y=0;
                // si tiene datos personales
                if(ref_Personal.length > 0 ){
                    y=135;
                    for (var i = 0; i < ref_Personal.length; i++) {
                        item=ref_Personal[i]
                        if (i < 3){
                            pdfDoc.setFontSize('10');
                            pdfDoc.setFontStyle('normal');
                            pdfDoc.text(15,y, pdfDoc.splitTextToSize( (i+1)+'.'+self.valorNull(item.name),180));
                            pdfDoc.text(130,y, pdfDoc.splitTextToSize('Teléfono:  '+self.valorNull(item.phone)+" "+self.valorNull(item.mobile),180));
                            y=y+5
                        }
                    }
                }else{
                    y=135;
                    pdfDoc.text(15,y,  pdfDoc.splitTextToSize('1. ........................................',180));
                    pdfDoc.text(130,y, pdfDoc.splitTextToSize('Teléfono: .................................',180));
                    y=y+5;
                    pdfDoc.text(15,y,  pdfDoc.splitTextToSize('1. ........................................',180));
                    pdfDoc.text(130,y, pdfDoc.splitTextToSize('Teléfono: .................................',180));
                }
                // si tiene datos comerciales
                if(ref_Comercial.length > 0 ){
                    y=155;
                    for (var i = 0; i < ref_Comercial.length; i++) {
                        item=ref_Comercial[i]
                        if (i < 3){
                            pdfDoc.setFontSize('10');
                            pdfDoc.setFontStyle('normal');
                            pdfDoc.text(15,y, pdfDoc.splitTextToSize( (i+1)+'.'+self.valorNull(item.name),180));
                            pdfDoc.text(130,y, pdfDoc.splitTextToSize('Teléfono:  '+self.valorNull(item.phone)+" "+self.valorNull(item.mobile),180));
                            y=y+5
                        }
                    }
                }else{
                    y=155;
                    pdfDoc.text(15,y,  pdfDoc.splitTextToSize('1. ........................................',180));
                    pdfDoc.text(130,y, pdfDoc.splitTextToSize('Teléfono: .................................',180));
                    y=y+5;
                    pdfDoc.text(15,y,  pdfDoc.splitTextToSize('1. ........................................',180));
                    pdfDoc.text(130,y, pdfDoc.splitTextToSize('Teléfono: .................................',180));
                }
                pdfDoc.save('SOLICITUD_CREDITO_PERSONAL.pdf');
          }
        },
    });
    if(openerp.web && openerp.web.FormView){
        openerp.web.FormView.include({
          load_form: function(){
              if(this.model === 'res.partner'){
                var padre = this.$el.closest('.oe_clear.ui-tabs.ui-widget.ui-widget-content.ui-corner-all');
                if (padre){
                    var partnerPrint = new openerp.partner_print_credit.PrintCreditWidget(this);
                    partnerPrint.insertBefore(padre);
                }
              }
              return this._super.apply(this, arguments);
          }
        });
    }
})();
